/*
This is an Ozeki Stepper Motor Controller Module example code.

It can control a maximum of 4 stepper motors of any type.
The enable, MS1 (microstep1), MS2, MS3, step and direction pins are default pins
for all 4 motor drivers (driver X, Y, Z, A).

The motors are called by the axes: X,Y,Z,A.
First it turns the motors 50 steps clockwise
one by one from motor X to A.
Then it turns the motors 50 steps counterclockwise
one by one from motor A to X.

This code repeats the above mentioned algorithm in a loop.
*/

struct StepperMotor{
  int enPin;
  int MS1;
  int MS2;
  int MS3;
  int stepPin;
  int dirPin;
};

StepperMotor X = {A4, A3, A2, A1, 11, 10};
StepperMotor Y = {A8, A7, A6, A5, 6, 7};
StepperMotor Z = {A12, A11, A10, A9, 5, 3};
StepperMotor A = {28, 27, 26, 25, 45, 46};

StepperMotor myMotors[4] = {X,Y,Z,A};

void setup() { 
  for(int i=0; i<=4; i++){//sets all 4 motor
    pinMode(myMotors[i].enPin,OUTPUT); 
    pinMode(myMotors[i].MS1,OUTPUT); 
    pinMode(myMotors[i].MS2,OUTPUT); 
    pinMode(myMotors[i].MS3,OUTPUT); 
    pinMode(myMotors[i].stepPin,OUTPUT); 
    pinMode(myMotors[i].dirPin,OUTPUT);

    //disables motors and sets them to 1/16 Step:
    digitalWrite(myMotors[i].enPin,HIGH);
    digitalWrite(myMotors[i].MS1,HIGH);
    digitalWrite(myMotors[i].MS1,HIGH);
    digitalWrite(myMotors[i].MS1,HIGH);
  }
}

void loop() {
  for(int i=0; i<=4; i++){ //turns all 4 motors clockwise
    digitalWrite(myMotors[i].enPin,LOW);
    digitalWrite(myMotors[i].dirPin,HIGH); //sets direction clockwise
      for(int x = 0; x < 50; x++) { //makes 50 steps clockwise
        digitalWrite(myMotors[i].stepPin,HIGH);
        delayMicroseconds(500); 
        digitalWrite(myMotors[i].stepPin,LOW);
        delayMicroseconds(500); 
      }
   digitalWrite(myMotors[i].enPin,HIGH);
  }  
  delay(1000); // One second delay

  for(int i=4; i>=0; i--){ //turns all 4 motors counterclockwise
    digitalWrite(myMotors[i].enPin,LOW);
    digitalWrite(myMotors[i].dirPin,LOW); //sets direction counterclockwise
      for(int x = 0; x < 50; x++) { //makes 50 steps counterclockwise
        digitalWrite(myMotors[i].stepPin,HIGH);
        delayMicroseconds(500); 
        digitalWrite(myMotors[i].stepPin,LOW);
        delayMicroseconds(500); 
      }
    digitalWrite(myMotors[i].enPin,HIGH);
  }  
  delay(1000); // One second delay
}
